
/*--------------------------------------------------------------------
   Copyright 1991, 1992 Don McGregor

   A subclass of FormCell that allows testing for several types of
   input in additon to the usual.
   
   It does this by overriding the isEntryAcceptable: method, which is
   what is used to check the validity of entries, and a couple others.
   
   Copyright 1992 Don McGregor
   You may freely use this code in any way you wish.
   however, you may not charge any money for the use
   of it.
   
   No warranty of any kind, etc, etc.
  
 --------------------------------------------------------------------*/


#import <appkit/FormCell.h>
#import <appkit/NXBrowserCell.h>
#import <appkit/NXBrowser.h>
#import <objc/HashTable.h>

	//apparently these aren't defined anywhere?
	
#define NX_CENTERED  	2
#define NX_RIGHTALIGNED	1
#define NX_LEFTALIGNED  0	

@interface GeneralFormCell:FormCell
{
  SEL	entryQual;	//the SEL that's the active entry checking method
}

- init;

-(BOOL)isEntryAcceptable:(const char *)aString;

	//Field entry qualifiers for all types, doubles, floats, and ints, etc
	
-(BOOL)anyType:(const char *)aString;
	
-(BOOL)isDouble:(const char *)aString;
-(BOOL)posDouble:(const char *)aString;
-(BOOL)nonNegDouble:(const char *)aString;

-(BOOL)isFloat:(const char *)aString;
-(BOOL)posFloat:(const char *)aString;
-(BOOL)nonNegFloat:(const char *)aString;

-(BOOL)isInt:(const char *)aString;
-(BOOL)posInt:(const char *)aString;
-(BOOL)nonNegInt:(const char *)aString;

-(BOOL)isDate:(const char *)aString;
-(BOOL)isSSN:(const char*)aString;

-(BOOL)isNumber:(const char*)aString;

	//routines for setting and reading qualifier names
	
-setEntryQual:(NXAtom)aString;
-(NXAtom)currentQualName;
	
	//IB inspector name
	
-(const char *)inspectorName;

	//Delegate methods for IB inspector

-(int)browser:sender fillMatrix:matrix inColumn:(int)column;
-(BOOL)browser:sender columnIsValid:(int)column;

	//Archiving methods.

-write:typedStream;
-read:typedStream;
@end
